#!/bin/sh

account_add()
{
	local poolid
	local user
	local pass
	local start
	local expire
	local bindmac
	local maxonline
	local bindip
	local outvlan
	local cname
	local phone
	local card
	local other
		

	for val in `echo $*`
	do
		eval "${val}"
	done
	
	: ${maxonline:=1}
	: ${bindip:='0.0.0.0'}
	
	if [ "${pool_name}" != "" ]; then
		# id name start end ipleft nextip acctcnt ratein rateout dns0 dns1 maxonlinetime clntepa ifname vlan others
		poolid="`${FLOWEYE} pppoeippool list | awk -v n="${pool_name}" '{if(n==$2){printf $1;exit;}}'`"
	fi

	cmdargs="poolid=${poolid} name=${user} password=${pass}"
	cmdargs="${cmdargs} start=${start} expire=${expire}"
	if [ "${bindmac}" != "" -a "${bindmac}" != "00-00-00-00-00-00" ]; then
		cmdargs="${cmdargs} bindmac=${bindmac}"
	fi

	[ "${maxonline}" != "1" ] && cmdargs="${cmdargs} maxonline=${maxonline}"
	[ "${bindip}" != "0.0.0.0" ] && cmdargs="${cmdargs} bindip=${bindip}"
	[ "${outvlan}" != "" ] && cmdargs="${cmdargs} outvlan=${outvlan}"
	[ "${cname}" != "" ] && cmdargs="${cmdargs} cname=${cname}"
	[ "${phone}" != "" ] && cmdargs="${cmdargs} phone=${phone}"
	[ "${card}"  != "" ] && cmdargs="${cmdargs} card=${card}"
	[ "${other}" != "" ] && cmdargs="${cmdargs} other=${other}"

	${FLOWEYE} pppoeacct add ${cmdargs}
}


account_set()
{
	local poolid
	local user
	local pass
	local start
	local expire
	local bindmac
	local maxonline
	local bindip
	local outvlan
	local cname
	local phone
	local card
	local other
	local pool_name
		

	for val in `echo $*`
	do
		eval "${val}"
	done
	
	: ${maxonline:=1}
	: ${bindip:='0.0.0.0'}
	
	if [ "${pool_name}" != "" ]; then
		# id name start end ipleft nextip acctcnt ratein rateout dns0 dns1 maxonlinetime clntepa ifname vlan others
		poolid="`${FLOWEYE} pppoeippool list | awk -v n="${pool_name}" '{if(n==$2){printf $1;exit;}}'`"
	fi

	cmdargs="poolid=${poolid} name=${user} password=${pass}"
	cmdargs="${cmdargs} start=${start} expire=${expire}"
	if [ "${bindmac}" != "" -a "${bindmac}" != "00-00-00-00-00-00" ]; then
		cmdargs="${cmdargs} bindmac=${bindmac}"
	fi

	cmdargs="${cmdargs} maxonline=${maxonline}"
	[ "${bindip}" != "0.0.0.0" ] && cmdargs="${cmdargs} bindip=${bindip}"
	[ "${outvlan}" != "" ] && cmdargs="${cmdargs} outvlan=${outvlan}"
	[ "${cname}" != "" ] && cmdargs="${cmdargs} cname=${cname}"
	[ "${phone}" != "" ] && cmdargs="${cmdargs} phone=${phone}"
	[ "${card}"  != "" ] && cmdargs="${cmdargs} card=${card}"
	[ "${other}" != "" ] && cmdargs="${cmdargs} other=${other}"

	${FLOWEYE} pppoeacct set ${cmdargs}
}

account_del()
{
	local cmdargs=""

	for acct in ${*}
	do
		cmdargs="${cmdargs} name=${acct}"
	done

	${FLOWEYE} pppoeacct remove ${cmdargs}
}

account_enable()
{
	local cmdargs=""

	for acct in ${*}
	do
		cmdargs="${cmdargs} accten=${acct}"
	done

	${FLOWEYE} pppoeacct config ${cmdargs}
}

account_disable()
{
	local cmdargs=""

	for acct in ${*}
	do
		cmdargs="${cmdargs} acctdis=${acct}"
	done
	
	${FLOWEYE} pppoeacct config ${cmdargs}
}



