#!/bin/sh

ippool_add()
{
	local name
	local ifname
	local vlan
	local svcname
	local maxip
	local maxdial
	local start
	local end
	local ratein
	local rateout
	local dns
	local maxonlinetime
	local clntepa
	

	for val in `echo $*`
	do
		eval "${val}"
	done


	: ${clntepa:='reject'}
	: ${ifname:='NULL'}

	cmdargs="name=${name}"
	[ "${start}" != "" -a "${start}" != "0.0.0.0" ] && cmdargs="${cmdargs} start=${start}"
	[ "${end}" != "" -a "${end}" != "0.0.0.0" ] && cmdargs="${cmdargs} end=${end}"
	[ "${ratein}" != "" ] && cmdargs="${cmdargs} ratein=${ratein}"
	[ "${rateout}" != "" ] && cmdargs="${cmdargs} rateout=${rateout}"
	[ "${dns}" != "" ] && cmdargs="${cmdargs} dns=${dns}"
	[ "${maxonlinetime}" != "" ] && cmdargs="${cmdargs} maxonlinetime=${maxonlinetime}"
	cmdargs="${cmdargs} clntepa=${clntepa}"
	[ "${ifname}" != "NULL" ] && cmdargs="${cmdargs} ifname=${ifname}"
	[ "${vlan}" != "" -a "${vlan}" != "0" ] && cmdargs="${cmdargs} vlan=${vlan}"
	[ "${maxip}" != "" -a "${maxip}" != "0" ] && cmdargs="${cmdargs} maxip=${maxip}"
	[ "${maxdial}" != "" -a "${maxdial}" != "0" ] && cmdargs="${cmdargs} maxdial=${maxdial}"

	${FLOWEYE} pppoeippool add ${cmdargs}
}

ippool_set()
{
	local id
	local name
	local ifname
	local vlan
	local svcname
	local maxip
	local maxdial
	local start
	local end
	local ratein
	local rateout
	local dns
	local maxonlinetime
	local clntepa
	

	for val in `echo $*`
	do
		eval "${val}"
	done
	
	if [ "${pool_name}" != "" ]; then
		id="`${FLOWEYE} pppoeippool list | awk -v n="${pool_name}" '{if(n==$2){printf $1;exit;}}'`"
	fi

	if [ "${id}" = "" ]; then
		echo "NO_POOLID"
		return 1
	fi

	: ${clntepa:='reject'}
	: ${ifname:='NULL'}
	
	: ${start:='0.0.0.0'}
	: ${end:='0.0.0.0'}
	
	: ${ratein:=0}
	: ${rateout:=0}
	: ${dns:='0.0.0.0'}
	: ${maxonlinetime:=0}
	: ${vlan:=0}
	: ${svcname:='NULL'}
	: ${maxip:=0}
	: ${maxdial:=0}

	cmdargs="id=${id} name=${name} start=${start} end=${end}"
	cmdargs="${cmdargs} ratein=${ratein} rateout=${rateout} dns=${dns}"
	cmdargs="${cmdargs} clntepa=${clntepa} maxonlinetime=${maxonlinetime}"
	cmdargs="${cmdargs} ifname=${ifname} vlan=${vlan} svcname=${svcname}"
	cmdargs="${cmdargs} maxip=${maxip} maxdial=${maxdial}"

	${FLOWEYE} pppoeippool set ${cmdargs}
}

ippool_del()
{
	local id

	for val in `echo $*`
	do
		eval "${val}"
	done
	
	if [ "${name}" != "" ]; then
		id="`${FLOWEYE} pppoeippool list | awk -v n="${name}" '{if(n==$2){printf $1;exit;}}'`"
	fi

	if [ "${id}" = "" ]; then
		echo "NO_POOLID"
		return 1
	fi

	${FLOWEYE} pppoeippool remove id=${id}
}

ippool_lst()
{
	local id

	for val in `echo $*`
	do
		eval "${val}"
	done
	
	${FLOWEYE} pppoeippool get id=${id}
}

ippool_lst()
{
	${FLOWEYE} pppoeippool list
}
