#!/bin/sh

iwanmap_set()
{
	local svrid
	local proxy
	local port
	local iwansvc_name
	

	for val in `echo $*`
	do
		eval "${val}"
	done

	: ${svrid:='NULL'}
	: ${port:=0}

	if [ "${iwansvc_name}" != "" ]; then
		svrid=`${FLOWEYE} nat listproxy type=lan | awk -v n="${iwansvc_name}" '{if(n==$3){printf $2;exit;}}'`
	fi

	cmdargs="proxy=${proxy} port=${port} server=${svrid}"

	${FLOWEYE} iwanmap set ${cmdargs}
}

iwanmap_del()
{
	local proxy
	local port
	

	for val in `echo $*`
	do
		eval "${val}"
	done

	: ${port:=0}

	cmdargs="proxy=${proxy} port=${port} server=NULL"

	${FLOWEYE} iwanmap set ${cmdargs}
}

iwanmap_lst()
{
#	pxyname pxyid port svrname svrid pkts

	${FLOWEYE} iwanmap list
}


